# Contributing to WWLayout
We love your input! We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features
- Becoming a maintainer

## We Develop with Github
We use github to host code, to track issues and feature requests, as well as accept pull requests.

### All Code Changes Happen Through Pull Requests
Pull requests are the best way to propose changes to the codebase. We actively welcome your pull requests:

1. Fork the repo and create your branch from `develop`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs, update the documentation.
4. Ensure the test suite passes.
5. Issue that pull request!

## Any contributions you make will be under the Apache-2.0 Software License
In short, when you submit code changes, your submissions are understood to be under the same [Apache-2.0 License](http://choosealicense.com/licenses/apache-2.0/) that covers the project. Feel free to contact the maintainers if that's a concern.

## Report bugs using Github's [issues](https://github.com/WW-Tech/wwlayout/issues)
We use GitHub issues to track public bugs. Report a bug by [opening a new issue](https://github.com/WW-Tech/wwlayout/issues/new); it's that easy!

## Write bug reports with detail, background, and sample code

**Great Bug Reports** tend to have:

- A quick summary and/or background
- Steps to reproduce
  - Be specific!
  - Give sample code if you can.
- What you expected would happen
- What actually happens
- Notes (possibly including why you think this might be happening, or stuff you tried that didn't work)

People *love* thorough bug reports. I'm not even kidding.

## Use a Consistent Coding Style
Please try to follow the style already established.

* 4 spaces for indentation rather than tabs
* Add comments to your code: [self-documenting code is a fallacy](https://www.sicpers.info/2018/04/lets-talk-about-self-documenting-code/)

## License
By contributing, you agree that your contributions will be licensed under WWLayout's Apache-2.0 License.

